From cf7b21bc2d6c3d3d12934598f7b6e24a7b2b5de0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 21:21:48 +0000
Subject: [PATCH 1275/2232] Preserve more than just the two default exported dirs


---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
index 43d262a..558956d 100644
--- a/gen/build/src/deps.rs
+++ b/gen/build/src/deps.rs
@@ -7,23 +7,26 @@ use std::path::PathBuf;
 pub struct Crate {
     pub include_prefix: Option<PathBuf>,
     pub links: Option<OsString>,
-    pub crate_dir: Option<PathBuf>,
-    pub include_dir: Option<PathBuf>,
+    pub exported_header_dirs: Vec<PathBuf>,
 }
 
 impl Crate {
     pub fn print_to_cargo(&self) {
         if let Some(include_prefix) = &self.include_prefix {
-            println!("cargo:CXXBRIDGE_PREFIX={}", include_prefix.to_string_lossy());
+            println!(
+                "cargo:CXXBRIDGE_PREFIX={}",
+                include_prefix.to_string_lossy(),
+            );
         }
         if let Some(links) = &self.links {
             println!("cargo:CXXBRIDGE_LINKS={}", links.to_string_lossy());
         }
-        if let Some(crate_dir) = &self.crate_dir {
-            println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
-        }
-        if let Some(include_dir) = &self.include_dir {
-            println!("cargo:CXXBRIDGE_INCLUDE={}", include_dir.to_string_lossy());
+        for (i, exported_dir) in self.exported_header_dirs.iter().enumerate() {
+            println!(
+                "cargo:CXXBRIDGE_DIR{}={}",
+                i,
+                exported_dir.to_string_lossy(),
+            );
         }
     }
 }
@@ -64,17 +67,18 @@ pub fn direct_dependencies() -> Vec<Crate> {
             continue;
         }
 
-        if k.ends_with("_CXXBRIDGE_CRATE") {
-            k.truncate(k.len() - "_CXXBRIDGE_CRATE".len());
-            crates.entry(k).or_default().crate_dir = Some(PathBuf::from(v));
+        let without_counter = k.trim_end_matches(|ch: char| ch.is_ascii_digit());
+        let counter_len = k.len() - without_counter.len();
+        if counter_len == 0 || !without_counter.ends_with("_CXXBRIDGE_DIR") {
             continue;
         }
 
-        if k.ends_with("_CXXBRIDGE_INCLUDE") {
-            k.truncate(k.len() - "_CXXBRIDGE_INCLUDE".len());
-            crates.entry(k).or_default().include_dir = Some(PathBuf::from(v));
-            continue;
-        }
+        k.truncate(k.len() - counter_len - "_CXXBRIDGE_DIR".len());
+        crates
+            .entry(k)
+            .or_default()
+            .exported_header_dirs
+            .push(PathBuf::from(v));
     }
 
     crates.into_iter().map(|entry| entry.1).collect()
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 2ec45e0..8c4e999 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -180,12 +180,18 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
     let crate_dir = make_crate_dir(prj);
     let include_dir = make_include_dir(prj)?;
-    let this_crate = Crate {
+    let mut this_crate = Crate {
         include_prefix: Some(prj.include_prefix.clone()),
         links: env::var_os("CARGO_MANIFEST_LINKS"),
-        crate_dir,
-        include_dir: Some(include_dir),
+        exported_header_dirs: Vec::new(),
     };
+
+    // The crate_dir is placed after the generated code directory (include_dir)
+    // on the include line so that `#include "path/to/file.rs"` from C++
+    // "magically" works and refers to the API generated from that Rust source
+    // file.
+    this_crate.exported_header_dirs.push(include_dir);
+    this_crate.exported_header_dirs.extend(crate_dir);
     this_crate.print_to_cargo();
 
     let mut build = Build::new();
@@ -201,17 +207,9 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
     eprintln!("\nCXX include path:");
     for krate in crates {
-        if let Some(include_dir) = &krate.include_dir {
-            build.include(include_dir);
-            eprintln!("  {}", include_dir.display());
-        }
-        if let Some(crate_dir) = &krate.crate_dir {
-            // Placed after the generated code directory (include_dir) on the
-            // include line so that `#include "path/to/file.rs"` from C++
-            // "magically" works and refers to the API generated from that Rust
-            // source file.
-            build.include(crate_dir);
-            eprintln!("  {}", crate_dir.display());
+        for header_dir in &krate.exported_header_dirs {
+            build.include(header_dir);
+            eprintln!("  {}", header_dir.display());
         }
     }
 

